using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace ADX_SpellingCheck_CS
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void btnRun_Click(object sender, EventArgs e)
		{
			AddinModule addinModule = AddinModule.CurrentInstance as AddinModule;

			richTextBox.SelectAll();
			richTextBox.SelectionColor = Color.Black;
			object Template = Type.Missing;
			object NewTemplate = Type.Missing;
			object DocumentType = Type.Missing;
			object Visible = false;
			Word.Documents docs = addinModule.WordApp.Documents;
			if (docs != null)
				try
				{
					Word._Document document = docs.Add(ref Template, ref NewTemplate, ref DocumentType, ref Visible);
					if (document != null)
						try
						{
							Word.Range range = document.Content;
							if (range != null)
								try
								{
									range.Text = richTextBox.Text;
									int Count = FindSpellingErrors(document);
									object SaveChanges = Word.WdSaveOptions.wdDoNotSaveChanges;
									object OriginalFormat = Type.Missing;
									object RouteDocument = Type.Missing;
									document.Close(ref SaveChanges, ref OriginalFormat, ref RouteDocument);
									if (Count == 0)
										MessageBox.Show("There are no errors!", "Add-in Express HowTo");
									else
										MessageBox.Show(string.Format("{0} Error(s) were found!", Count), "Add-in Express HowTo");
								}
								finally
								{
									Marshal.ReleaseComObject(range);
								}
						}
						finally
						{
							Marshal.ReleaseComObject(document);
						}
				}
				finally
				{
					Marshal.ReleaseComObject(docs);
				}
		}

		private int FindSpellingErrors(Word._Document document)
		{
			int ret = 0;
			document.SpellingChecked = false;
			Word.ProofreadingErrors spellingErrors = document.SpellingErrors as Word.ProofreadingErrors;
			if (spellingErrors != null)
				try
				{
					ret = spellingErrors.Count;
					for (int i = 1; i <= spellingErrors.Count; i++)
					{
						Word.Range error = spellingErrors.Item(i);
						if (error != null)
							try
							{
								richTextBox.Find(error.Text,
									error.Start,
									RichTextBoxFinds.MatchCase |
									RichTextBoxFinds.WholeWord);
								richTextBox.SelectionColor = Color.Red;
							}
							finally
							{
								Marshal.ReleaseComObject(error);
							}
					}
				}
				finally
				{
					Marshal.ReleaseComObject(spellingErrors);
				}
			return ret;
		}
	}
}